// score: 30
// slow dp solution with less memory
// O(n^2 B^2) if food values are <= 2 A B
#include <bits/stdc++.h>
using namespace std;

constexpr int inf = 1e9;

int cdiv(int a, int b){
    assert(0 < b);
    if(a > 0) return (a + b-1)/b;
    return a/b;
}

template<typename T>
void xmin(T&a, T const&b){
    a = min(a, b);
}

signed main(){
    int n, A, B;
    cin >> n >> A >> B;
    vector<int> v(n);
    for(auto &e:v) cin >> e;
    const int S = accumulate(v.begin(), v.end(), 0);
    const int X = S/A+n+2;
    vector<int> dp(X, inf);
    auto dp2 = dp;
    dp[0] = 0;
    for(int i=0; i<n; ++i){
        fill(dp2.begin(), dp2.end(), inf);
        const int e = v[i];
        for(int a=0; a <= e/A+1; ++a){
            const int b = (max(0, e-a*A)+B-1)/B;
            for(int x = 0; x < X-a; ++x){
                xmin(dp2[x+a], dp[x] + b);
            }
        }
        dp.swap(dp2);
    }
    int ans = inf;
    for(int i=0; i<X; ++i){
        xmin(ans, cdiv(dp[i], A) + cdiv(i, B));
    }
    cout << ans << "\n";
}
