# score: 100

from collections import deque
import sys

n, m, k, q = map(int, sys.stdin.readline().split())

par = list(range(n))
def f(x):
    if par[x] == x:
        return x
    par[x] = f(par[x])
    return par[x]

def u(a, b):
    par[f(a)] = f(b)

for _ in range(m):
    a, b = map(int, sys.stdin.readline().split())
    u(a, b)

gr = [set() for _ in range(n)]
for _ in range(k):
    a, b = map(int, sys.stdin.readline().split())
    gr[f(a)].add(f(b))
    gr[f(b)].add(f(a))

dist = [[-1] * n for _ in range(n)]
for a in range(n):
    a = f(a)
    di = dist[a]
    if di[a] != -1:
        continue
    qu = deque()
    qu.append(a)
    di[a] = 0
    while qu:
        ae = qu.popleft()
        for nei in gr[ae]:
            nei = f(nei)
            if di[nei] != -1:
                continue
            di[nei] = di[ae] + 1
            qu.append(nei)

for _ in range(q):
    a, b = map(int, sys.stdin.readline().split())
    print(dist[f(a)][f(b)])
