// score:  0
// might give 15p
/*
Bibin
Score: prob. 0?
*/

#include <bits/stdc++.h>

using namespace std;

#define int long long

int N, A, B;
vector<int> G;



int amountB(int g, int a){
	return max(0.0, ceil(1.0 * (g - a*A) / B));
}

bool greedy(int pizzaA, int pizzaB){

	int slizeA = pizzaA*B;
	int slizeB = pizzaB*A;

	for(int g: G){
		int mini = 1e18;
		int miniA = 0;
		for(int a = 0; a <= slizeA && (a-1)*A <= g; a++){
			int b = amountB(g, a);


			/*if(pizzaA + pizzaB == 1){
				cout << "D: " << a << " " << b << " " << slizeA << " " << slizeB << " " << mini << " " << miniA << endl;
			}*/



			if(b > slizeB) continue;

			if(b*B + a*A < mini){
				mini = b*B + a*A;
				miniA = a;
			}
		}

		if(mini == 1e18){
			return false;
		}

		slizeA -= miniA;
		slizeB -= amountB(g, miniA);
	}

	return true;
}

bool test(int p){
	for(int a = 0; a <= p; a++){
		if(greedy(a, p-a)){
			return true;
		}
	}

	return false;
}

int solve(){

	int low = 0, high = 2*N;
	while(high - low > 1){
		int m = low + (high - low)/2;
		if(test(m)){
			high = m;
		}else{
			low = m;
		}
	}

	return high;

}

signed main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> A >> B;
    G = vector<int>(N);
    int64_t add = 0;
    for(int i = 0; i < N; i++){
    	cin >> G[i];
    	int x = max<int>(0, G[i]/(A*B)-1);
    	G[i] -= x*A*B;
    	add += x;
    }
    
    int ans = 1e9;
    mt19937 rng(523971);
    sort(G.begin(), G.end());
    for(int it=0; it<50; ++it){
        ans = min(ans, solve());
        shuffle(G.begin(), G.end(), rng);
    }

    cout << ans+add << "\n";
}
