// score: 70
// medium speed dp solution
// O(n B^2)
#include <bits/stdc++.h>
using namespace std;

constexpr int64_t inf = 1e18;

int64_t cdiv(int64_t a, int64_t b){
    assert(0 < b);
    if(a > 0) return (a + b-1)/b;
    return a/b;
}

template<typename T>
void xmin(T&a, T const&b){
    a = min(a, b);
}

signed main(){
    int T = 1;
    // cin >> T;
    while(T--){
        int n, A, B;
        cin >> n >> A >> B;
        vector<int> v(n);
        for(auto &e:v) cin >> e;
        const int X = 2*B;
        vector<int64_t> dp(X, inf);
        auto dp2 = dp;
        dp[0] = 0;
        for(int i=0; i<n; ++i){
            fill(dp2.begin(), dp2.end(), inf);
            const int e = v[i];
            for(int a=0; a <= min(B, e/A+1); ++a){
                const int64_t b = (max<int64_t>(0, e-a*A)+B-1)/B;
                for(int x = 0; x < X-a; ++x){
                    xmin(dp2[x+a], dp[x] + b);
                }
            }
            // replace whole pizzas by whole pizzas
            for(int i=X-1; i>=B; --i){
                xmin(dp2[i-B], dp2[i] + A);
            }
            dp.swap(dp2);
        }
        int64_t ans = inf;
        for(int i=0; i<X; ++i){
            xmin(ans, cdiv(dp[i], A) + cdiv(i, B));
        }
        cout << ans << "\n";
    }
}
