// score: 30
// slow dp solution
// O(n^2 B^2) if food values are <= 2 A B
#include <bits/stdc++.h>
using namespace std;

constexpr int inf = 1e9;

int cdiv(int a, int b){
    assert(0 < b);
    if(a > 0) return (a + b-1)/b;
    return a/b;
}

template<typename T>
void xmin(T&a, T const&b){
    a = min(a, b);
}

signed main(){
    cin.exceptions(ios::badbit | ios::eofbit | ios::failbit);
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, A, B;
    cin >> n >> A >> B;
    vector<int> v(n);
    for(auto &e:v) cin >> e;
    const int S = accumulate(v.begin(), v.end(), 0);
    const int X = S/A+n+2;
    vector<vector<int> > dp(n+1, vector<int> (X, inf));
    dp[0][0] = 0;
    for(int i=0; i<n; ++i){
        const int e = v[i];
        for(int a=0; a <= e/A+1; ++a){
            const int b = cdiv(max(0, e-a*A), B);
            for(int x = 0; x < X-a; ++x){
                xmin(dp[i+1][x+a], dp[i][x] + b);
            }
        }
    }
    int ans = inf;
    for(int i=0; i<X; ++i){
        xmin(ans, cdiv(dp[n][i], A) + cdiv(i, B));
    }
    cout << ans << "\n";
}
