# score: 100
import sys

N, J = list(map(int, sys.stdin.readline().split()))
a = list(map(int, sys.stdin.readline().split()))
b = list(map(int, sys.stdin.readline().split()))

assert len(a) == N
assert len(b) == N

bmin = 0
bmax = 2*10**9

while bmin < bmax:
    mid = (bmin + bmax + 1) // 2

    needed = 0
    for i in range(N):
        needed += max(0, mid * a[i] - b[i])
    if needed <= J:
        bmin = mid
    else:
        bmax = mid - 1

print(str(bmin))
